"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const postcss_simple_vars_1 = __importDefault(require("postcss-simple-vars"));
const utils_1 = require("./utils");
const plugin = () => {
    return {
        postcssPlugin: 'postcss-text-transform',
        AtRule: {
            'text-transform': (rule, helpers) => {
                var _a;
                try {
                    const params = utils_1.processParams(rule.params);
                    const transformed = utils_1.transform(params);
                    const proxy = new helpers.Root();
                    rule.nodes.forEach((node) => {
                        const clone = node.clone();
                        proxy.append(clone);
                    });
                    const variables = { [params.result]: transformed };
                    const processor = helpers.postcss([postcss_simple_vars_1.default({ only: variables })]);
                    processor.process(proxy).root;
                    (_a = rule.parent) === null || _a === void 0 ? void 0 : _a.insertBefore(rule, proxy);
                    rule.remove();
                }
                catch (error) {
                    throw rule.error(error);
                }
            },
        },
    };
};
plugin.postcss = true;
module.exports = plugin;
